package com.scottlogic.util;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import org.junit.Test;
import static org.junit.Assert.*;

public class NaturalSortedListTest {

	//Test whether the NaturalSortedList sorts integer into the expected order.
	@Test
	public void testWithIntegers(){
		NaturalSortedList<Integer> nsl = new NaturalSortedList<Integer>();
		List<Integer> regList = new ArrayList<Integer>();
		
		for(int i = 0; i < 1000; i++){
			int toAdd = i%10;
			nsl.add(toAdd);
			nsl.add(0-toAdd); //add negatives too..
			regList.add(toAdd);
			regList.add(0-toAdd);
		}

		Collections.sort(regList); //should put it in the same order as nsl list..
		
		assertEquals(regList.size(), nsl.size());
		Iterator<Integer> nslItr = nsl.iterator();
		Iterator<Integer> regListItr = regList.iterator();
		while(regListItr.hasNext()){
			assertEquals(regListItr.next(), nslItr.next());
		}
	}
}
